using System;
using System.IO;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Globalization;

using CADImport;

using System.Drawing.Imaging;
using System.Drawing.Drawing2D;

namespace CADImportForm
{
	public class Form1 : System.Windows.Forms.Form
	{
		private const int OnMouseScroll = 522;
		private Form2 lForm = new Form2();
		private Point pos = new Point();
		private static Form1 actForm;
		private Rectangle curClRect;
		private float wh;
		private CADIterate CADParams;
		private ArrayList TextFile = new ArrayList();
		private float scale = 1;
		private SFPoint ScaleRect = new SFPoint();

		private int cX, cY;
		private bool det1;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.StatusBar stBar;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem mExit;
		private System.Windows.Forms.MenuItem mOpenFile;
		private System.Windows.Forms.MenuItem mSaveFile;
		private System.Windows.Forms.MenuItem mFile;
		private System.Windows.Forms.MenuItem mView;
		private System.Windows.Forms.MenuItem mScale;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.MenuItem menuItem9;
		private System.Windows.Forms.MenuItem menuItem10;
		public System.Windows.Forms.StatusBarPanel sbOpen;
		private System.Windows.Forms.StatusBarPanel sbScale;
		private System.Windows.Forms.ColorDialog dlgSetColor;
		private System.Windows.Forms.ToolBarButton tlbOpen;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.ToolBarButton tlbZoomIn;
		private System.Windows.Forms.ToolBarButton tlbZoomOut;
		private System.Windows.Forms.ToolBarButton tlbSave;
		private System.Windows.Forms.ToolBarButton tlbWhite;
		private System.Windows.Forms.ToolBarButton tlbBlack;
		private System.Windows.Forms.ToolBarButton tlbColor;
		private System.Windows.Forms.ToolBar tlbTool;
		private System.Windows.Forms.SaveFileDialog saveImgDlg;
		private System.Windows.Forms.ToolBarButton tlbOSX;
		private System.Windows.Forms.ToolBarButton tlb3d;
		private System.Windows.Forms.ToolBarButton tlbLay;
		private System.Windows.Forms.ToolBarButton tlbArcPoly;
		private System.Windows.Forms.ToolBarButton tlbArcGdi;
		private System.Windows.Forms.ToolBarButton tlbBlackMode;
		private System.Windows.Forms.ToolBarButton tlbColorMode;
		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.Windows.Forms.MenuItem menuItem11;
		private System.Windows.Forms.MenuItem menuItem12;
		private System.Windows.Forms.MenuItem menuItem13;
		private System.Windows.Forms.MenuItem menuItem14;
		private System.Windows.Forms.MenuItem menuItem15;
		private System.Windows.Forms.MenuItem menuItem16;
		private System.Windows.Forms.MenuItem menuItem17;
		private System.Windows.Forms.MenuItem menuItem18;
		private System.Windows.Forms.MenuItem menuItem19;
		private System.Windows.Forms.MenuItem menuItem20;
		private System.Windows.Forms.MenuItem menuItem21;
		private System.Windows.Forms.StatusBarPanel sbCoord;
		private Orbit3D Orb3D = new Orbit3D();

		private void Zoom(float i)
		{
			if(FCADImage == null) return;
			scale = scale*i;
			if(scale < 0.05f) scale = 0.05f;
			pictureBox1.Invalidate();
			stBar.Panels[1].Text = "" + scale;
		}

		protected override void WndProc(ref Message m)
		{
			if(m.Msg == OnMouseScroll) 
			{
				if(m.WParam.ToInt32() < 0)  Zoom(0.9f);
				else Zoom(1.1f);
				
			} 
			else base.WndProc(ref m);
		}

		private System.ComponentModel.IContainer components;

		public Form1()
		{
			InitializeComponent();
			Initial3DOrbit();
		}

		private void Initial3DOrbit()
		{
			Orb3D.Parent = this.pictureBox1;
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.saveImgDlg = new System.Windows.Forms.SaveFileDialog();
			this.stBar = new System.Windows.Forms.StatusBar();
			this.sbOpen = new System.Windows.Forms.StatusBarPanel();
			this.sbScale = new System.Windows.Forms.StatusBarPanel();
			this.sbCoord = new System.Windows.Forms.StatusBarPanel();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.mFile = new System.Windows.Forms.MenuItem();
			this.mOpenFile = new System.Windows.Forms.MenuItem();
			this.mSaveFile = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.mExit = new System.Windows.Forms.MenuItem();
			this.mView = new System.Windows.Forms.MenuItem();
			this.mScale = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.menuItem8 = new System.Windows.Forms.MenuItem();
			this.menuItem9 = new System.Windows.Forms.MenuItem();
			this.menuItem10 = new System.Windows.Forms.MenuItem();
			this.dlgSetColor = new System.Windows.Forms.ColorDialog();
			this.tlbTool = new System.Windows.Forms.ToolBar();
			this.tlbOpen = new System.Windows.Forms.ToolBarButton();
			this.tlbZoomIn = new System.Windows.Forms.ToolBarButton();
			this.tlbZoomOut = new System.Windows.Forms.ToolBarButton();
			this.tlbSave = new System.Windows.Forms.ToolBarButton();
			this.tlbWhite = new System.Windows.Forms.ToolBarButton();
			this.tlbBlack = new System.Windows.Forms.ToolBarButton();
			this.tlbColor = new System.Windows.Forms.ToolBarButton();
			this.tlb3d = new System.Windows.Forms.ToolBarButton();
			this.contextMenu1 = new System.Windows.Forms.ContextMenu();
			this.menuItem11 = new System.Windows.Forms.MenuItem();
			this.menuItem12 = new System.Windows.Forms.MenuItem();
			this.menuItem13 = new System.Windows.Forms.MenuItem();
			this.menuItem14 = new System.Windows.Forms.MenuItem();
			this.menuItem15 = new System.Windows.Forms.MenuItem();
			this.menuItem16 = new System.Windows.Forms.MenuItem();
			this.menuItem17 = new System.Windows.Forms.MenuItem();
			this.menuItem18 = new System.Windows.Forms.MenuItem();
			this.menuItem19 = new System.Windows.Forms.MenuItem();
			this.menuItem20 = new System.Windows.Forms.MenuItem();
			this.menuItem21 = new System.Windows.Forms.MenuItem();
			this.tlbOSX = new System.Windows.Forms.ToolBarButton();
			this.tlbLay = new System.Windows.Forms.ToolBarButton();
			this.tlbArcPoly = new System.Windows.Forms.ToolBarButton();
			this.tlbArcGdi = new System.Windows.Forms.ToolBarButton();
			this.tlbBlackMode = new System.Windows.Forms.ToolBarButton();
			this.tlbColorMode = new System.Windows.Forms.ToolBarButton();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			((System.ComponentModel.ISupportInitialize)(this.sbOpen)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.sbScale)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.sbCoord)).BeginInit();
			this.SuspendLayout();
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.DefaultExt = "*.dxf";
			this.openFileDialog1.Filter = "*.dxf|*.dxf";
			// 
			// pictureBox1
			// 
			this.pictureBox1.BackColor = System.Drawing.Color.White;
			this.pictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pictureBox1.Cursor = System.Windows.Forms.Cursors.Default;
			this.pictureBox1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pictureBox1.Location = new System.Drawing.Point(0, 0);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(689, 297);
			this.pictureBox1.TabIndex = 8;
			this.pictureBox1.TabStop = false;
			this.pictureBox1.Paint += new System.Windows.Forms.PaintEventHandler(this.pictureBox1_Paint);
			this.pictureBox1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.pictureBox1_MouseUp);
			this.pictureBox1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pictureBox1_MouseMove);
			this.pictureBox1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.pictureBox1_MouseDown);
			// 
			// saveImgDlg
			// 
			this.saveImgDlg.DefaultExt = "*.bmp";
			this.saveImgDlg.Filter = "*.bmp|*.bmp|*.jpg|*.jpg";
			// 
			// stBar
			// 
			this.stBar.Font = new System.Drawing.Font("Microsoft Sans Serif", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.stBar.Location = new System.Drawing.Point(0, 281);
			this.stBar.Name = "stBar";
			this.stBar.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																					 this.sbOpen,
																					 this.sbScale,
																					 this.sbCoord});
			this.stBar.ShowPanels = true;
			this.stBar.Size = new System.Drawing.Size(689, 16);
			this.stBar.TabIndex = 9;
			// 
			// sbOpen
			// 
			this.sbOpen.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents;
			this.sbOpen.MinWidth = 100;
			this.sbOpen.ToolTipText = "File Name";
			// 
			// sbScale
			// 
			this.sbScale.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.sbScale.ToolTipText = "Scale";
			this.sbScale.Width = 522;
			// 
			// sbCoord
			// 
			this.sbCoord.Alignment = System.Windows.Forms.HorizontalAlignment.Right;
			this.sbCoord.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents;
			this.sbCoord.Text = "0 - 0 - 0";
			this.sbCoord.Width = 51;
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mFile,
																					  this.mView,
																					  this.menuItem9});
			// 
			// mFile
			// 
			this.mFile.Index = 0;
			this.mFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																				  this.mOpenFile,
																				  this.mSaveFile,
																				  this.menuItem2,
																				  this.mExit});
			this.mFile.Text = "&File";
			// 
			// mOpenFile
			// 
			this.mOpenFile.Index = 0;
			this.mOpenFile.Text = "&Open File...";
			this.mOpenFile.Click += new System.EventHandler(this.Open_Click);
			// 
			// mSaveFile
			// 
			this.mSaveFile.Enabled = false;
			this.mSaveFile.Index = 1;
			this.mSaveFile.Text = "Save File As...";
			this.mSaveFile.Click += new System.EventHandler(this.ImgSave_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 2;
			this.menuItem2.Text = "-";
			// 
			// mExit
			// 
			this.mExit.Index = 3;
			this.mExit.Text = "&Exit";
			this.mExit.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// mView
			// 
			this.mView.Index = 1;
			this.mView.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																				  this.mScale});
			this.mView.Text = "&View";
			// 
			// mScale
			// 
			this.mScale.Enabled = false;
			this.mScale.Index = 0;
			this.mScale.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																				   this.menuItem1,
																				   this.menuItem3,
																				   this.menuItem4,
																				   this.menuItem5,
																				   this.menuItem6,
																				   this.menuItem7,
																				   this.menuItem8});
			this.mScale.Text = "&Scale";
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.Text = "10%";
			this.menuItem1.Click += new System.EventHandler(this.menuItem1_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 1;
			this.menuItem3.Text = "25%";
			this.menuItem3.Click += new System.EventHandler(this.menuItem1_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 2;
			this.menuItem4.Text = "50%";
			this.menuItem4.Click += new System.EventHandler(this.menuItem1_Click);
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 3;
			this.menuItem5.Text = "100%";
			this.menuItem5.Click += new System.EventHandler(this.menuItem1_Click);
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 4;
			this.menuItem6.Text = "200%";
			this.menuItem6.Click += new System.EventHandler(this.menuItem1_Click);
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 5;
			this.menuItem7.Text = "400%";
			this.menuItem7.Click += new System.EventHandler(this.menuItem1_Click);
			// 
			// menuItem8
			// 
			this.menuItem8.Index = 6;
			this.menuItem8.Text = "800%";
			this.menuItem8.Click += new System.EventHandler(this.menuItem1_Click);
			// 
			// menuItem9
			// 
			this.menuItem9.Index = 2;
			this.menuItem9.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem10});
			this.menuItem9.Text = "&?";
			// 
			// menuItem10
			// 
			this.menuItem10.Index = 0;
			this.menuItem10.Text = "&About";
			this.menuItem10.Click += new System.EventHandler(this.menuItem10_Click);
			// 
			// tlbTool
			// 
			this.tlbTool.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
			this.tlbTool.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.tlbTool.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																					   this.tlbOpen,
																					   this.tlbZoomIn,
																					   this.tlbZoomOut,
																					   this.tlbSave,
																					   this.tlbWhite,
																					   this.tlbBlack,
																					   this.tlbColor,
																					   this.tlb3d,
																					   this.tlbOSX,
																					   this.tlbLay,
																					   this.tlbArcPoly,
																					   this.tlbArcGdi,
																					   this.tlbBlackMode,
																					   this.tlbColorMode});
			this.tlbTool.DropDownArrows = true;
			this.tlbTool.ImageList = this.imageList1;
			this.tlbTool.Location = new System.Drawing.Point(0, 0);
			this.tlbTool.Name = "tlbTool";
			this.tlbTool.ShowToolTips = true;
			this.tlbTool.Size = new System.Drawing.Size(689, 29);
			this.tlbTool.TabIndex = 10;
			this.tlbTool.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.tlbTool_ButtonClick);
			// 
			// tlbOpen
			// 
			this.tlbOpen.ImageIndex = 1;
			// 
			// tlbZoomIn
			// 
			this.tlbZoomIn.Enabled = false;
			this.tlbZoomIn.ImageIndex = 3;
			// 
			// tlbZoomOut
			// 
			this.tlbZoomOut.Enabled = false;
			this.tlbZoomOut.ImageIndex = 4;
			// 
			// tlbSave
			// 
			this.tlbSave.Enabled = false;
			this.tlbSave.ImageIndex = 2;
			// 
			// tlbWhite
			// 
			this.tlbWhite.Enabled = false;
			this.tlbWhite.ImageIndex = 5;
			// 
			// tlbBlack
			// 
			this.tlbBlack.Enabled = false;
			this.tlbBlack.ImageIndex = 6;
			// 
			// tlbColor
			// 
			this.tlbColor.Enabled = false;
			this.tlbColor.ImageIndex = 0;
			// 
			// tlb3d
			// 
			this.tlb3d.DropDownMenu = this.contextMenu1;
			this.tlb3d.Enabled = false;
			this.tlb3d.ImageIndex = 7;
			this.tlb3d.Style = System.Windows.Forms.ToolBarButtonStyle.DropDownButton;
			// 
			// contextMenu1
			// 
			this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.menuItem11,
																						 this.menuItem12,
																						 this.menuItem13,
																						 this.menuItem14,
																						 this.menuItem15,
																						 this.menuItem16,
																						 this.menuItem17,
																						 this.menuItem18,
																						 this.menuItem19,
																						 this.menuItem20,
																						 this.menuItem21});
			// 
			// menuItem11
			// 
			this.menuItem11.Index = 0;
			this.menuItem11.Text = "Initial View";
			this.menuItem11.Click += new System.EventHandler(this.menuItem11_Click);
			// 
			// menuItem12
			// 
			this.menuItem12.Index = 1;
			this.menuItem12.Text = "Top View";
			this.menuItem12.Click += new System.EventHandler(this.menuItem12_Click);
			// 
			// menuItem13
			// 
			this.menuItem13.Index = 2;
			this.menuItem13.Text = "Bottom View";
			this.menuItem13.Click += new System.EventHandler(this.menuItem13_Click);
			// 
			// menuItem14
			// 
			this.menuItem14.Index = 3;
			this.menuItem14.Text = "Left View";
			this.menuItem14.Click += new System.EventHandler(this.menuItem14_Click);
			// 
			// menuItem15
			// 
			this.menuItem15.Index = 4;
			this.menuItem15.Text = "Right View";
			this.menuItem15.Click += new System.EventHandler(this.menuItem15_Click);
			// 
			// menuItem16
			// 
			this.menuItem16.Index = 5;
			this.menuItem16.Text = "Front View";
			this.menuItem16.Click += new System.EventHandler(this.menuItem16_Click);
			// 
			// menuItem17
			// 
			this.menuItem17.Index = 6;
			this.menuItem17.Text = "Back View";
			this.menuItem17.Click += new System.EventHandler(this.menuItem17_Click);
			// 
			// menuItem18
			// 
			this.menuItem18.Index = 7;
			this.menuItem18.Text = "SW Isometric";
			this.menuItem18.Click += new System.EventHandler(this.menuItem18_Click);
			// 
			// menuItem19
			// 
			this.menuItem19.Index = 8;
			this.menuItem19.Text = "SE Isometic";
			this.menuItem19.Click += new System.EventHandler(this.menuItem19_Click);
			// 
			// menuItem20
			// 
			this.menuItem20.Index = 9;
			this.menuItem20.Text = "NE Isometric";
			this.menuItem20.Click += new System.EventHandler(this.menuItem20_Click);
			// 
			// menuItem21
			// 
			this.menuItem21.Index = 10;
			this.menuItem21.Text = "NW Isometric";
			this.menuItem21.Click += new System.EventHandler(this.menuItem21_Click);
			// 
			// tlbOSX
			// 
			this.tlbOSX.Enabled = false;
			this.tlbOSX.ImageIndex = 8;
			this.tlbOSX.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			// 
			// tlbLay
			// 
			this.tlbLay.Enabled = false;
			this.tlbLay.ImageIndex = 9;
			// 
			// tlbArcPoly
			// 
			this.tlbArcPoly.Enabled = false;
			this.tlbArcPoly.ImageIndex = 10;
			this.tlbArcPoly.Pushed = true;
			this.tlbArcPoly.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.tlbArcPoly.Tag = "";
			// 
			// tlbArcGdi
			// 
			this.tlbArcGdi.Enabled = false;
			this.tlbArcGdi.ImageIndex = 11;
			this.tlbArcGdi.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.tlbArcGdi.Tag = "";
			// 
			// tlbBlackMode
			// 
			this.tlbBlackMode.Enabled = false;
			this.tlbBlackMode.ImageIndex = 13;
			this.tlbBlackMode.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			// 
			// tlbColorMode
			// 
			this.tlbColorMode.Enabled = false;
			this.tlbColorMode.ImageIndex = 12;
			this.tlbColorMode.Pushed = true;
			this.tlbColorMode.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Control;
			this.ClientSize = new System.Drawing.Size(689, 318);
			this.Controls.Add(this.tlbTool);
			this.Controls.Add(this.stBar);
			this.Controls.Add(this.pictureBox1);
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "CADImport.Net Demo";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.Resize += new System.EventHandler(this.Form1_Resize);
			this.Load += new System.EventHandler(this.Form1_Load);
			this.Activated += new System.EventHandler(this.Form1_Activated);
			this.Deactivate += new System.EventHandler(this.Form1_Deactivate);
			((System.ComponentModel.ISupportInitialize)(this.sbOpen)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.sbScale)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.sbCoord)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		protected CADImage FCADImage;
		[STAThread]
		static void Main() 
		{
			actForm = new Form1();
			Application.Run(actForm);			
		}

		private void Open_Click(object sender, System.EventArgs e)
		{
			pictureBox1.Visible = false;
			pos = new Point();
			if(openFileDialog1.ShowDialog(this) != DialogResult.OK) 
			{
				pictureBox1.Visible = true;
				return;
			}
			if (openFileDialog1.FileName != null)
			{
				scale = 1;
				FCADImage = null;
				FCADImage = new CADImage(pictureBox1.CreateGraphics());
				FCADImage.Load(openFileDialog1.FileName);
				Form1_Resize(sender, e);
				pictureBox1.Invalidate();
			} 
			stBar.Panels[1].Text = "" + scale;
			stBar.Panels[0].Text = Path.GetFileName(openFileDialog1.FileName);
			for(int i = 1; i < 14; i++)
				tlbTool.Buttons[i].Enabled = true;
			tlbTool.Buttons[8].Pushed = FCADImage.isDraw3DAxes;
			tlbTool.Buttons[10].Pushed = true;
			tlbTool.Buttons[11].Pushed = false;
			tlbTool.Buttons[12].Pushed = false;
			tlbTool.Buttons[13].Pushed = true;
			FCADImage.useWinEllipse = false;
			mScale.Enabled = true;
			mSaveFile.Enabled = true;
			Orb3D.cADImage = FCADImage;
			pictureBox1.Visible = true;
			if(pictureBox1.BackColor == Color.White)
				White_Click();
			else Black_Click();
		}

		private void ZoomIn_Click(object sender, System.EventArgs e)
		{
			if(FCADImage == null) return;
			scale = scale * 2;
			pictureBox1.Invalidate();
			stBar.Panels[1].Text = "" + scale;
		}

		private void ZoomOut_Click(object sender, System.EventArgs e)
		{
			if(FCADImage == null) return;
			scale = scale / 2;
			pictureBox1.Invalidate();
			stBar.Panels[1].Text = "" + scale;
		}

		private void pictureBox1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			if(FCADImage == null) return;
			try
			{
				Rectangle tmp = new Rectangle();
				tmp = curClRect;
				tmp.Width = (int)(tmp.Width*scale);
				tmp.Height = (int)(tmp.Height*scale);
				tmp.X += pos.X;
				tmp.Y += pos.Y;
				FCADImage.Draw(e.Graphics, tmp);
			}
			catch
			{
				pictureBox1.Visible = false;
			}
		}

		private void pictureBox1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			det1 = false;
			pictureBox1.Cursor = Cursors.Default;
			pictureBox1.Invalidate();
		}

		private void pictureBox1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if(e.Button == MouseButtons.Right) 
			{
				Form1.ActiveForm.Cursor = Cursors.Hand;
				cX = e.X;
				cY = e.Y;
				det1 = true;
			}
		}

		private void pictureBox1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			pictureBox1.Focus();
			if(FCADImage == null) return;
			if((det1)&&(!Orb3D.visible))
			{
				pos.X -= (cX - e.X);
				pos.Y -= (cY - e.Y);
				cX = e.X;
				cY = e.Y;
				pictureBox1.Invalidate();
			}
			SFPoint vPt = GetRealPointUsingsgImagePoint(e.X, e.Y);
			stBar.Panels[2].Text = "" + vPt.X + " : " + vPt.Y + " : 0";
		}

		private SFPoint GetRealPointUsingsgImagePoint(int X, int Y)
		{
			Rectangle tmp = new Rectangle();
			tmp = curClRect;
			FRect Rect = new FRect(tmp.Left, tmp.Top,
				tmp.Right, tmp.Bottom);
			float fKoef = FCADImage.AbsHeight() / FCADImage.AbsWidth();
			Rect.left = Rect.left  * scale + pos.X;
			Rect.right = Rect.right * scale + pos.X;
			Rect.top = Rect.top * scale + pos.Y;			
			Rect.bottom = Rect.top  + (Rect.right - Rect.left) *   fKoef;						
			ScaleRect.X = FCADImage.AbsWidth() / (Rect.right - Rect.left);
			ScaleRect.Y = FCADImage.AbsHeight() / (Rect.bottom - Rect.top);
			SFPoint mousePt = new SFPoint(0 ,0, 0);
			SFPoint newmousePt = new SFPoint(0 ,0, 0);
			SFPoint pX, pY, pCenter;
			FRect frectExtentsCAD = FCADImage.extents;
			mousePt.X = frectExtentsCAD.left + (X - pos.X) * ScaleRect.X;
			mousePt.Y = frectExtentsCAD.top  - (Y - pos.Y) * ScaleRect.Y;
			pCenter.X = 0.5f * (frectExtentsCAD.right + frectExtentsCAD.left);
			pCenter.Y = 0.5f * (frectExtentsCAD.top + frectExtentsCAD.bottom);
			pCenter.Z = 0.5f * (frectExtentsCAD.z2 + frectExtentsCAD.z1);
			pX.X = 1; pX.Y = 0;	pX.Z = 0;
			pY.X = 0; pY.Y = 1;	pY.Z = 0;		
			pX = FCADImage.GetRealImagePoint(pX);
			pY = FCADImage.GetRealImagePoint(pY);
			MoveToPosition(ref mousePt, pCenter, -1);
			newmousePt.X = mousePt.X * pX.X + mousePt.Y * pX.Y;
			newmousePt.Y = mousePt.X * pY.X + mousePt.Y * pY.Y;
			MoveToPosition(ref newmousePt, pCenter, +1);
			return newmousePt;
		}

		private void MoveToPosition(ref SFPoint point, SFPoint pos, int direction)
		{  
			point.X = point.X + direction * pos.X;
			point.Y = point.Y + direction * pos.Y;
			point.Z = point.Z + direction * pos.Z;
		}

		private void ImgSave_Click(object sender, System.EventArgs e)
		{
			if(FCADImage == null) return;
			if(saveImgDlg.ShowDialog() != DialogResult.OK) return;
			if(saveImgDlg.FileName != null) 
			{
				string tmp = saveImgDlg.FileName;
				if(tmp.IndexOf(".jpg") != -1)
					FCADImage.SaveToFile(saveImgDlg.FileName, ImageFormat.Jpeg);
				if(tmp.IndexOf(".bmp") != -1)
					FCADImage.SaveToFile(saveImgDlg.FileName, ImageFormat.Bmp);
			}
		}

		private void Form1_Activated(object sender, System.EventArgs e)
		{
			pictureBox1.Visible = true;
		}

		private void Form1_Deactivate(object sender, System.EventArgs e)
		{
			det1 = false;
		}

		private void menuItem3_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		private void menuItem10_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show("CAD Import.Net full version "+ Convert.ToChar(13) + 
				Convert.ToChar(10) + 
				"www.cadsofttools.com ");
		}

		private void menuItem1_Click(object sender, System.EventArgs e)
		{
			if(FCADImage == null) return;
			float i = scale;
			switch((sender as MenuItem).Index)
			{
				case 0:
					i = 0.1f;
					break;
				case 1:
					i = 0.25f;
					break;
				case 2:
					i = 0.5f;
					break;
				case 3:
					i = 1;
					break;
				case 4:
					i = 2;
					break;
				case 5:
					i = 4;
					break;
				case 6:
					i = 8;
					break;
			}
			scale = i;
			pictureBox1.Invalidate();
			stBar.Panels[1].Text = "" + scale;
		}

		private void White_Click()
		{
			pictureBox1.BackColor = Color.White;
			FCADImage.defaultColor = Color.Black;
		}

		private void Black_Click()
		{
			pictureBox1.BackColor = Color.Black;
			FCADImage.defaultColor = Color.White;
		}

		private void Color_Click()
		{
			if(dlgSetColor.ShowDialog() == DialogResult.OK)
			{
				pictureBox1.BackColor = dlgSetColor.Color;
			}
		}

		private void tlbTool_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			if((FCADImage == null)&&(tlbTool.Buttons.IndexOf(e.Button) == 8)) return;
			switch(tlbTool.Buttons.IndexOf(e.Button))
			{
				case 0:
					lForm.chLay.Items.Clear();
					lForm.chLay.ItemCheck -= new System.Windows.Forms.ItemCheckEventHandler(this.chLay_ItemCheck);
					Open_Click(sender, e);
					break; 
				case 1:
					ZoomIn_Click(sender, e);
					break; 
				case 2:
					ZoomOut_Click(sender, e);
					break;
				case 3:
					ImgSave_Click(sender, e);
					break;
				case 4:
					White_Click();
					break;
				case 5:
					Black_Click();
					break;
				case 6:
					Color_Click();
					break;
				case 7:
					Go3dOrbit();
					pictureBox1.Invalidate();
					break;
				case 8:
					FCADImage.isDraw3DAxes = !FCADImage.isDraw3DAxes;
					pictureBox1.Invalidate();
					break;
				case 9:
					SetLayList();
					lForm.ShowDialog();
					break;
				case 10:
					FCADImage.useWinEllipse = false; 
					tlbTool.Buttons[11].Pushed = false;
					tlbTool.Buttons[10].Pushed = true;
					pictureBox1.Invalidate();
					break;
				case 11:
					FCADImage.useWinEllipse = true; 
					tlbTool.Buttons[10].Pushed = false;
					tlbTool.Buttons[11].Pushed = true;
					pictureBox1.Invalidate();
					break;
				case 12:
					FCADImage.DrawMode = CADDrawMode.dmBlack;
					tlbTool.Buttons[12].Pushed = true;
					tlbTool.Buttons[13].Pushed = false;
					pictureBox1.Invalidate();
					break;
				case 13:
					FCADImage.DrawMode = CADDrawMode.dmNormal;
					tlbTool.Buttons[12].Pushed = false;
					tlbTool.Buttons[13].Pushed = true;
					pictureBox1.Invalidate();
					break;
				/*case 14:
					ReadAll(@"E:\1.txt");
					break;*/
			}
		}

		private void SetLayList()
		{
			if((lForm.chLay.Items.Count != 0)||FCADImage == null) return;
			for(int I = 0; I < FCADImage.converter.layers.entities.Count; I++)
			{
				lForm.chLay.Items.Add(((CADLayer)FCADImage.converter.layers.entities[I]).name,
					((CADLayer)FCADImage.converter.layers.entities[I]).visible);
			}
			lForm.chLay.ItemCheck += new System.Windows.Forms.ItemCheckEventHandler(this.chLay_ItemCheck);
		}

		private void chLay_ItemCheck(object sender, System.Windows.Forms.ItemCheckEventArgs e)
		{
			if(e.NewValue == CheckState.Checked)
				((CADLayer)FCADImage.converter.layers.entities[e.Index]).visible = true;
			if(e.NewValue == CheckState.Unchecked) 
				((CADLayer)FCADImage.converter.layers.entities[e.Index]).visible = false;
			pictureBox1.Invalidate();
		}

		private void Go3dOrbit()
		{
			Orb3D.visible = !Orb3D.visible;
			det1 = false;
			if(Orb3D.visible) Orb3D.Enable3dOrbit();
			else Orb3D.Disable3dOrbit();
		}

		private void Form1_Resize(object sender, System.EventArgs e)
		{
			if(FCADImage == null) return;
			if(FCADImage.isDraw3DAxes)
			{
				FCADImage.isDraw3DAxes = false;
				FCADImage.isDraw3DAxes = true;
			}
			//set real size image
			wh = FCADImage.AbsWidth() / FCADImage.AbsHeight(); 
			float new_wh = (float)pictureBox1.ClientRectangle.Width / (float)pictureBox1.ClientRectangle.Height;
			curClRect = actForm.ClientRectangle;
			if(new_wh > wh)
				curClRect.Width	= (int)(curClRect.Height * wh);
			else 
			{
				if(new_wh < wh)
					curClRect.Height = (int)(curClRect.Width / wh);
				else
					curClRect = actForm.ClientRectangle;
			}
			pos.X = (actForm.ClientRectangle.Width - curClRect.Width) / 2;
			pos.Y = (actForm.ClientRectangle.Height - curClRect.Height) / 2;
			pictureBox1.Invalidate();
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			wh = 1f;
			curClRect = actForm.ClientRectangle;
		}

		private void menuItem17_Click(object sender, System.EventArgs e)
		{
			FCADImage.RotToView(CADViewDirection.vdBack);
			pictureBox1.Invalidate();
		}

		private void menuItem12_Click(object sender, System.EventArgs e)
		{
			FCADImage.RotToView(CADViewDirection.vdTop);
			pictureBox1.Invalidate();
		}

		private void menuItem13_Click(object sender, System.EventArgs e)
		{
			FCADImage.RotToView(CADViewDirection.vdBottom);
			pictureBox1.Invalidate();
		}

		private void menuItem14_Click(object sender, System.EventArgs e)
		{
			FCADImage.RotToView(CADViewDirection.vdLeft);
			pictureBox1.Invalidate();
		}

		private void menuItem15_Click(object sender, System.EventArgs e)
		{
			FCADImage.RotToView(CADViewDirection.vdRight);
			pictureBox1.Invalidate();
		}

		private void menuItem16_Click(object sender, System.EventArgs e)
		{
			FCADImage.RotToView(CADViewDirection.vdFront);
			pictureBox1.Invalidate();
		}

		private void menuItem18_Click(object sender, System.EventArgs e)
		{
			FCADImage.RotToView(CADViewDirection.vdSWIsometric);
			pictureBox1.Invalidate();
		}

		private void menuItem19_Click(object sender, System.EventArgs e)
		{
			FCADImage.RotToView(CADViewDirection.vdSEIsometric);
			pictureBox1.Invalidate();
		}

		private void menuItem20_Click(object sender, System.EventArgs e)
		{
			FCADImage.RotToView(CADViewDirection.vdNEIsometric);
			pictureBox1.Invalidate();
		}

		private void menuItem21_Click(object sender, System.EventArgs e)
		{
			FCADImage.RotToView(CADViewDirection.vdNWIsometric);
			pictureBox1.Invalidate();
		}

		private void menuItem11_Click(object sender, System.EventArgs e)
		{
			FCADImage.RotDefault();
			pictureBox1.Invalidate();
		}
	}
}
